﻿;
; VIM.ahk       do like VIM  - AutoHotKey Script        Author: H.Kawakami  2017.2.22
;
;     このスクリプトでは
;     IMEの設定は、[変換キー]でIMEをON、[無変換キー]でIMEをOFFに設定されている事を条件としている。
;         IME の状態復元は、この条件下で実行可です。
;     エクセルで編集に切替るには、e , または, Ctrl+ e を押します。
;
;     他、各モードから抜けるには、Ctrl+ｊ or  Ctrl+［  or  Esc　としています。
;
;              改造が容易なので、自分のお好きなように改造下さい。
;
#NoEnv                       ; Recommended for performance and compatibility with future AutoHotkey releases.
#Warn                        ; Enable warnings to assist with detecting common errors.
SendMode Input               ; Recommended for new scripts due to its superior speed and reliability.
; SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.

                                                   ; このｽｸﾘﾌﾟﾄを使わないCLASS や EXEはここに！
 GroupAdd Vim,            ahk_class Vim            ;   もちろん　Vim　では使えませんね。

                                                   ; 以降　ｱﾌﾟﾘｹｰｼｮﾝ別　個別処理
GroupAdd EXCEL,          ahk_class XLMAIN          ;   ｴｸｾﾙで使えるようにするのに苦労しております。

GroupAdd Graph,          ahk_exe   DraftSight.exe  ; ESCキーが効かなくなったりした事がありました。

GroupAdd NeedRstKbFocus, ahk_class Notepad         ; to change caret width
GroupAdd NeedRstKbFocus, ahk_class WordPadClass    ;   in a app required to reset keyboard focus.

GroupAdd ToolTipOFF,     ahk_class Notepad         ; ToolTip を表示したいｱﾌﾟﾘｹｰｼｮﾝ
GroupAdd ToolTipOFF,     ahk_class WordPadClass
GroupAdd ToolTipOFF,     ahk_exe   DraftSight.exe

GroupAdd WORD,           ahk_class OpusApp         ; MS-Wordo

GroupAdd Graph,          ahk_exe   DraftSight.exe

Gui,New  ; キーボードフォーカスを一瞬失わせるためのダミーとして生成している。それ以外の意味なし。

; Auto-execute section - begin
    i_mode =  0   ; insert mode
    c_mode =  0   ; change
    d_mode =  0   ; delete
    v_mode =  0   ; visual
    sv_mode = 0   ; shift-visual
    y_mode =  0   ; yank

    yy_dd_flag = 0 ; yy dd flag

    IME_On =  0   ; i_mode が1→0変化時のIME状態記憶用

    clearAllMode()

; Auto-execute section - end
Return

isModeCleared() {  ; 仕様：下の各modeの内,一つだけが０以外になれる。同時に0以外にならない。
    global i_mode, c_mode,  d_mode,  v_mode,  sv_mode,  y_mode
    return not (i_mode + c_mode + d_mode + v_mode + sv_mode + y_mode)
}

change_caretW(cW) {  ; caret幅を変更         注）App側でcaretを表示しているものは、変化しません。
    DllCall("SystemParametersInfo", "UInt", 8199, "UInt", 0, "UInt",  cW, "UInt", 3)
    ; -------------------------------------------------------------------------------
    ;        param 1: SPI_SETCARETWIDTH(value: 8199)
    ;              2: 0
    ;              3: ByVal CaretWidth(value: 1 から　20）
    ;              4: SPIF_UPDATEINIFILE(value:1) Or SPIF_SENDWININICHANGE(value:2)
    ; --------------------------------------------------------------------------------

    if (WInActive("ahk_group NeedRstKbFocus"))  ; caret幅が DLLCall(,8199,,)だけでは変更されない物に対応。
    {                                           ; このようなことはしたくないが、別の解決策が見当たらない
        ;don't work { hwnd := WinExist("A")  DllCall("HideCaret",UInt,hwnd) DllCall("ShowCaret",UInt,hwnd) }
        Gui,Show                                ;  Guiに一瞬だけfocusを渡す。渡したくないのだが。
        Gui,Cancel                              ;  focusを戻すと、変更後のcaret widthで表示される様になる。
    }
}

clearAllMode() {
    global i_mode, c_mode,  d_mode,  v_mode,  sv_mode,  y_mode,  yy_dd_flag

    if (not isModeCleared()) {
        i_mode = 0
        c_mode = 0
        d_mode = 0
        v_mode = 0
        sv_mode = 0
        y_mode = 0
        yy_dd_flag = 0

        change_caretW(6)    ; 文字入力ガイドのキャレット幅を変更
        showToolTip()       ; マウスポインター付近にToolTipを表示して、マウスを追っかけます。
    }
}
set_i_mode() {
    global i_mode
    i_mode = 1
    change_caretW(1)
    hideToolTip()
}
set_v_mode() {
    global v_mode
    v_mode = 1
    change_caretW(12)  ; VIMに倣い、キャレットを太くする。 全てのAPPでの対応は出来ていません。
}
set_sv_mode() {
    global sv_mode
    sv_mode = 1
    change_caretW(12)
}
set_c_mode() {
    global c_mode
    c_mode = 1
    change_caretW(1)
}
set_d_mode() {
    global d_mode
    d_mode = 1
    change_caretW(6)
}
set_y_mode() {
    global y_mode
    y_mode = 1
}

showToolTip() {                ; ToolTipがマウスを追いかけるため、

    if (not WInActive("ahk_group ToolTipOFF"))   ;
        SetTimer, dspToolTip, 100  ; 100m秒毎にdspToolTip を呼出し
}

hideToolTip() {
    SetTimer, dspToolTip, off
    ToolTip
}

dspToolTip:
    if (not WInActive("ahk_group VIM"))
    {
        MouseGetPos, px, py
        if (v_mode) or (sv_mode)
            ToolTip, ∨, px+50, py+50

        if (isModeCleared())
            ToolTip, ◆, px+50, py+50
    }
    Return

restoreIME() {              ; IME を　i_mode時に復元する。
    global IME_On
    if (IME_On)             ; 直前のi_mode 時、IMEがどうだったかで分岐
    {
        Sleep,120           ; Sleepが短いとGoogle Input「あ」のポップアップが出て来ない。
        Send,{vk1Csc079}    ; 変換キー：IME ON にする
    }
    if (not IME_On)
    {
        Sleep,120           ; Sleepが短いとGoogle Input「A」のポップアップが出て来ない。
        Send,{vk1Dsc07B}    ; 無変換キー: IME OFF にする
    }
}
;   基礎知識     #:win   !:alt   ^:ctrl   +:shift   *:wild card
; ***************************************************************
;                 Vim_mode      start !!!
; ***************************************************************

; ---------------------------------------------------------------
#if (WInActive("ahk_group EXCEL")) and (not i_mode)
 a::
    clearAllMode()
    set_i_mode()
    restoreIME()
    Return

#if (not WInActive("ahk_group Vim")) and (not i_mode)
 a::
    Send,{Right}
    set_i_mode()
    restoreIME()
    Return

; ---------------------------------------------------------------
+a::
    Send,{End}
    set_i_mode()
    restoreIME()
    Return

#if (WInActive("ahk_group EXCEL")) and (isModeCleared())
 b::
+b::
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (isModeCleared())
 b::
+b::
    Send,^{Left}
^b::
    Return

#if (not WInActive("ahk_group Vim")) and (v_mode)
 b::
+b::
    Send,+^{Left}
    Return

#if (not WInActive("ahk_group Vim")) and (d_mode)
 b::
+b::
    Send,+^{Left}^x
    clearAllMode()
    Return

#if (not WInActive("ahk_group Vim")) and (not i_mode)
*b::
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (isModeCleared())
 c::
    set_c_mode()
    Return

#if (not WInActive("ahk_group Vim")) and (v_mode)
 c::
    Send,+{Right}^x
    clearAllMode()
    set_i_mode()
    Return

#if (not WInActive("ahk_group Vim")) and (c_mode)
 c::
    Send,{Home}+{End}^x
    clearAllMode()
    set_i_mode()
    yy_dd_flag = 0
    Return

#if (not WInActive("ahk_group Vim")) and (not i_mode)
 c::
+c::
    Return

#if (WInActive("ahk_group EXCEL")) and (isModeCleared())
 d::
        Send,{Delete}
        clearAllMode()
        yy_dd_flag = 0
        Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (isModeCleared())
 d::
    set_d_mode()
    Return

#if (not WInActive("ahk_group Vim")) and (d_mode)
 d::                                               ; dd comand
    Send,{Home}+{End}^x
    clearAllMode()
    yy_dd_flag = 1
    Return

#if (not WInActive("ahk_group Vim")) and ((v_mode) or (sv_mode))
 d::
    Send,^x
    clearAllMode()
    yy_dd_flag = 0
    Return

; ---------------------------------------------------------------
#if (WInActive("ahk_group WORD")) and (isModeCleared())
+d::
    Send,+{End}+{Left}^x
    yy_dd_flag = 0
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (isModeCleared())
+d::
    Send,+{End}^x
    yy_dd_flag = 0
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (isModeCleared())
^d::
    Send,{PgDn}
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (v_mode)
^d::
    Send,+{PgDn}
    Return
; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
*d::
    Return


#if (WInActive("ahk_group EXCEL")) and (isModeCleared())
 e::
^e::
    Send,{F2}      ;  エクセル セル内編集、または、入力へ
    Return

#if (WInActive("ahk_group EXCEL")) and (isModeCleared())
+e::
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (isModeCleared())
 e::
+e::
    Send,^{Right}{Left}
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (v_mode)
 e::
+e::
    Send,+^{Right}+{Left}
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
*e::
    Return

; ---------------------------------------------------------------
#if (WInActive("ahk_group EXCEL")) and (not i_mode)
^f::
    Send,^f  ; エクセルで　検索 ショートカットを使いたい。
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
*f::
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
 g::
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
+g::
    Send,^{End}
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
^g::
   Return

#if (not WInActive("ahk_group Vim")) and (isModeCleared())
 h::
    Send,{Left}
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (isModeCleared())
^h::
    Send,{Left}
    Return

#if (not WInActive("ahk_group Vim")) and (isModeCleared())
+h::
    Send,{Up 20}
    Return

; --- Move Cursor to Left ---------------------------------------
#if (not WInActive("ahk_group Vim")) and (d_mode)
 h::
^h::
   Send,{Left}{BackSpace}
   clearAllMode()
   Return

; --- Move Cursor to Left ---------------------------------------
#if (not WInActive("ahk_group Vim")) and (v_mode)
 h::
^h::
   Send,+{Left}

   Return

; --- Move Cursor to Left ---------------------------------------
#if (not WInActive("ahk_group Vim")) and (sv_mode)
 h::
^h::
   Return

; --- Move Cursor to Left ---------------------------------------
#if (not WInActive("ahk_group Vim")) and (y_mode)
 h::
^h::
   Send,{Left}
   clearAllMode()
   Return

; --- Ctrl H : BackSpase ----------------------------------------
#if (not WInActive("ahk_group Vim")) and (i_mode)
^h::
    Send,{BackSpace}
    Return

; ---------------------------------------------------------------
#if (WInActive("ahk_group EXCEL")) and (not i_mode)
 i::
    clearAllMode()
    set_i_mode()
    restoreIME()
    Return
 
; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
+i::
    Send,{Home}
 i::
    clearAllMode()
    set_i_mode()
    restoreIME()
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (i_mode)
^i::Send,{Tab}
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (isModeCleared())
 j::
    Send,{Down}
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (v_mode)
 j::
+j::
    Send,+{Down}
    Return

#if (not WInActive("ahk_group Vim")) and (sv_mode)
 j::
+j::
    Send,+{Down}
    Send,+{End}
    Return

; ---------------------------------------------------------------
#if (WInActive("ahk_group EXCEL")) and (i_mode)
^j::
    clearAllMode()
    Send,{vk1Dsc07B}
    Return

; ---------------------------------------------------------------
#if (WInActive("ahk_group EXCEL")) and (not i_mode)
^j::
    Send,{Enter}{Esc}{vk1Dsc07B}
+j::
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim"))
^j::
    clearAllMode()
    Send,{vk1Dsc07B}   ; IME OFF
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (isModeCleared())
 k::
    Send,{Up}
+k::
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (v_mode)
 k::
    Send,+{Up}
+k::
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (sv_mode)
 k::
    Send,+{Up}+{End}
+k::
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
*k::
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (i_mode)
^k::          ; outlookにて HyperLinkの挿入のｼｮｰﾄｶｯﾄを起動させない様にする。
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (isModeCleared())
 l::
    Send,{Right}
    Return

+l::
    Send,{Down 20}  ; 20は　適当な数字。
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (v_mode)
 l::
    Send,+{Right}
+l::
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
*l::
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (isModeCleared())
+m::
    Send,{Up 20}{Down 20}
 m::
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (i_mode)
^m::
    Send,{Enter}
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
^m::
    Send,{Down}
    clearAllMode()
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (isModeCleared())
 n::
    Return

#if (WInActive("ahk_group EXCEL")) and (not i_mode)
; ---------------------------------------------------------------
 o::
+o::
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (isModeCleared())
 o::
    Send,{End}{Enter}
    set_i_mode()
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (isModeCleared())
+o::
    Send,{Home}{Enter}{Up}
    set_i_mode()
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
*o::
    clearAllMode()
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (isModeCleared()) and (not yy_dd_flag)
 p::
+p::
    Send,^v            ; do paste
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (isModeCleared()) and (yy_dd_flag)
 p::
+p::
    Send,{End}{Enter}  ; make a new line under the cursor
    Send,^v            ; and do paste
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
*p::
    clearAllMode()
    Return

#if (not WInActive("ahk_group Vim")) and (not i_mode)
; ---------------------------------------------------------------
 q::
+q::
    Return

#if (not WInActive("ahk_group Vim"))
; ---------------------------------------------------------------
^q::
    Send,!{F4}  ; Close the actual window
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (isModeCleared())
 r::
    Send,{Delete}
    set_i_mode()
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (isModeCleared())
^r::
    Send,^y  ; reDo
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
*r::
    clearAllMode()
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
*s::
*t::
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (isModeCleared())
 u::
    Send,^z
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (isModeCleared())
^u::
    Send,{PgUp}
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (v_mode)
^u::
    Send,+{PgUp}
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
*u::
    clearAllMode()
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (v_mode)
 v::
+v::
    Send,{Left}{Right}
    clearAllMode()
    Gui,Show
    Gui,Hide
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (sv_mode)
 v::
+v::
    clearAllMode()
    set_v_mode()
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (isModeCleared())
 v::
    set_v_mode()
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (isModeCleared())
+v::
    Send,{Home}+{End}
    set_sv_mode()
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
 v::
+v::
    clearAllMode()
    Return

#if (WInActive("ahk_group EXCEL")) and (isModeCleared())
 w::
+w::
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (v_mode)
 w::
+w::
    Send,+^{Right}
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (c_mode)
 w::
+w::
    clearAllMode()
    set_i_mode()
#if (not WInActive("ahk_group Vim")) and (d_mode)
 w::
+w::
    Send,+^{Right}^x
    clearAllMode()
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
 w::
+w::
    Send,^{Right}
^w::
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
+x::
    Send,{left}
 x::
    Send,{Delete}
    clearAllMode()
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (y_mode)
 y::
    Send,{Home}+{End}
    Send,^c
    Send,{Left}{Right}
    clearAllMode()
    yy_dd_flag = 1
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and ((v_mode) or (sv_mode))
 y::
    Send,^c
    Send,{Left}{Right}
    clearAllMode()
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
 y::
    set_y_mode()
    Return

+y::
    Return

^y::
    Send,{Up}
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim"))
^z::
    Send,^z
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
*z::
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (d_mode)
 0::
    Send,+{Home}^x
    clearAllMode()
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (v_mode)
 0::
    Send,+{Home}
    yy_dd_flag = 0

    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
 0::Send,{Home}

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
1::
2::
3::
4::
5::
6::
7::
8::
9::
`::
~::
!::
@::
#::
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (c_mode)
 $::
    set_i_mode()
#if (not WInActive("ahk_group Vim")) and (d_mode)
 $::
    Send,+{End}^x
    clearAllMode()
    yy_dd_flag = 0
    Return

#if (not WInActive("ahk_group Vim")) and (v_mode)
 $::
    Send,+{End}
    yy_dd_flag = 0
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
 $::Send,{End}

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
%::
^::
&::
*::
(::
)::
-::
_::
=::
+::
[::
    Return

; ---------------------------------------------------------------
#if (WInActive("ahk_group EXCEL")) and (i_mode)
^[::
    clearAllMode()
    Send,{vk1Dsc07B}
    Return

; ---------------------------------------------------------------
#if (WInActive("ahk_group EXCEL")) and (not i_mode)
^[::
    Send,{Enter}{Esc}{vk1Dsc07B}
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim"))
^[::
    clearAllMode()
    Send,{vk1Dsc07B}
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
{::
]::
}::
\::
|::
;::
:::
'::
"::
,::
<::
    return

; ---------------------------------------------------------------
#if (WInActive("ahk_group EXCEL")) and (not i_mode)
 .::
    Send,{F4}       ; 繰り返し
    clearAllMode()
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
.::
>::
    Return

; ---------------------------------------------------------------
#if (WInActive("ahk_group EXCEL")) and (not i_mode)
Enter::
    Send,{Enter}
    clearAllMode()
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim"))
Esc::
    if (not WInActive("ahk_group Graph"))
        Send,{vk1Dsc07B}        ; IME OFF  draft-sightでｴｽｹｰﾌﾟが効かなくなる。

    Send,{Esc}
    clearAllMode()
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
Space::
    Send,{Right}
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (not i_mode)
vk1Csc079 ::    ; 変換キー　　　：　入力を無視
vkF3sc029 ::    ; 半角/全角キー ：　入力を無視
vkF4sc029 ::    ; 半角/全角キー ：　入力を無視
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (i_mode)
~vk1Csc079::
    IME_On = 1
    Return

; ---------------------------------------------------------------
#if (not WInActive("ahk_group Vim")) and (i_mode)
~vk1Dsc07B::
    IME_On = 0
    Return

; ■■■　終了　■■■

